﻿using Corsinvest.ProxmoxVE.Api;
using Newtonsoft.Json;
using ProxmoxConnector.Integration.Abstractions;
using System;
using System.Threading.Tasks;

namespace ProxmoxConnector.Integration.Corsinvest.Services
{
    internal class PveConnector : IPveConnector
    {
        public async Task Test()
        {
            var client = new PveClient("***REMOVED***"); ***REMOVED***
            if (await client.Login("root", "password"))
            {
                var vm = client.Nodes["pve1"].Qemu[100];

                //config vm
                var config = await vm.Config.VmConfig();
                Console.WriteLine(JsonConvert.SerializeObject(config.Response, Formatting.Indented));

                //create snapshot
                var response = await vm.Snapshot.Snapshot("pippo2311");

                //update snapshot description
                await vm.Snapshot["pippo2311"].Config.UpdateSnapshotConfig("description");

                //delete snapshot
                await vm.Snapshot["pippo2311"].Delsnapshot();

                //list of snapshot
                foreach (var snapshot in (await vm.Snapshot.SnapshotList()).Response.data)
                {
                    Console.WriteLine(JsonConvert.SerializeObject(snapshot, Formatting.Indented));
                    Console.WriteLine(snapshot.name);
                }

                //change response type from json to png
                client.ResponseType = ResponseType.Png;
                var dataImg = (await client.Nodes["pve1"].Rrd.Rrd("cpu", "day")).Response;
                Console.WriteLine("<img src=\"{dataImg}\" \\>");
            }

            //using Api Token
            var client2 = new PveClient("10.92.100.33");
            client2.ApiToken = "root@pam!qqqqqq=***REMOVED***";
            var version = await client2.Version.Version();
            Console.WriteLine(JsonConvert.SerializeObject(version.Response.data, Formatting.Indented));
        }
    }
}
